﻿Option Strict On

Imports System.Drawing

Imports System.IO

Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Imaging
Imports System.Windows.Threading
Imports Un4seen
Imports Un4seen.Bass

Public Class MainViewModel
    Inherits ViewModel.Instrastructure.ViewModelBase

    Public Spektrum As New Un4seen.Bass.Misc.Visuals
    Public streamfx As Integer
    Public VisualizationTimer As New DispatcherTimer
    Public BMP As Bitmap


    Public Sub New()
        If IsInDesignMode = False Then
            cbxIndex = 0
            Aufloesung = 1
            Distanz = 0
            Debug.WriteLine("Gestartet")
            _Hoehe = 100
            _Breite = 350
            VisualizationTimer.Interval = TimeSpan.FromMilliseconds(25)
            AddHandler VisualizationTimer.Tick, AddressOf UpdateVisualization
            Bass.BASS_Init(-1, 44100, BASSInit.BASS_DEVICE_CPSPEAKERS, IntPtr.Zero, Nothing)
            streamfx = Bass.BASS_StreamCreateFile("HIERDEINEMP3.mp3", 0, 0, BASSFlag.BASS_STREAM_AUTOFREE Or BASSFlag.BASS_STREAM_PRESCAN)
            Bass.BASS_ChannelPlay(streamfx, False)
            VisualizationTimer.Start()
        End If
    End Sub

    Private _cbxIndex As Integer
    Public Property cbxIndex As Integer
        Get
            Return _cbxIndex
        End Get
        Set(value As Integer)
            _cbxIndex = value
            RaisePropertyChanged()
        End Set
    End Property

    Private Sub UpdateVisualization(ByVal sender As Object, ByVal e As EventArgs)

        Select Case cbxIndex
            Case 0
                BMP = Spektrum.CreateSpectrumLine(streamfx, Breite, Hoehe, System.Drawing.Color.Green, System.Drawing.Color.IndianRed, System.Drawing.Color.Black, 40, 5, False, True, True)
            Case 1
                BMP = Spektrum.CreateSpectrumBean(streamfx, Breite, Hoehe, System.Drawing.Color.Green, System.Drawing.Color.IndianRed, System.Drawing.Color.Black, 40, False, True, True)
            Case 2
                BMP = Spektrum.CreateSpectrumDot(streamfx, Breite, Hoehe, System.Drawing.Color.Green, System.Drawing.Color.IndianRed, System.Drawing.Color.Black, 40, 5, False, True, True)
            Case 3
                BMP = Spektrum.CreateSpectrumEllipse(streamfx, Breite, Hoehe, System.Drawing.Color.Green, System.Drawing.Color.IndianRed, System.Drawing.Color.Black, 40, 5, False, True, True)
            Case 4
                BMP = Spektrum.CreateSpectrumLinePeak(streamfx, Breite, Hoehe, System.Drawing.Color.Green, System.Drawing.Color.IndianRed, System.Drawing.Color.SlateGray, System.Drawing.Color.Black, Aufloesung, 3, Distanz, 40, False, True, True)    'DAS HIER IST PERFEKT!!
            Case 5
                BMP = Spektrum.CreateSpectrum(streamfx, Breite, Hoehe, System.Drawing.Color.Green, System.Drawing.Color.IndianRed, System.Drawing.Color.Black, False, True, True)
            Case 6
                BMP = Spektrum.CreateSpectrumText(streamfx, Breite, Hoehe, System.Drawing.Color.Green, System.Drawing.Color.IndianRed, System.Drawing.Color.Black, "Hallo Welt", False, True, True)
            Case 7
                BMP = Spektrum.CreateSpectrumWave(streamfx, Breite, Hoehe, System.Drawing.Color.Green, System.Drawing.Color.IndianRed, System.Drawing.Color.Black, Aufloesung, False, True, True)
            Case 8
                BMP = Spektrum.CreateWaveForm(streamfx, Breite, Hoehe, System.Drawing.Color.Green, System.Drawing.Color.IndianRed, System.Drawing.Color.Purple, System.Drawing.Color.Black, Aufloesung, True, False, True)

        End Select

        Bild = BitmapToImageSource(BMP)


    End Sub

    Private _StoppeVisualisierung As ICommand
    Public ReadOnly Property StoppeVisualisierung() As ICommand
        Get
            If _StoppeVisualisierung Is Nothing Then _StoppeVisualisierung = New Instrastructure.RelayCommand(AddressOf StoppeVisualisierung_Execute, Function(o) True)
            Return _StoppeVisualisierung
        End Get
    End Property
    Private Sub StoppeVisualisierung_Execute(obj As Object)
        VisualizationTimer.Stop()
    End Sub

    Private Function BitmapToImageSource(ByVal bitmap As Bitmap) As BitmapImage
        Using memory As MemoryStream = New MemoryStream()
            bitmap.Save(memory, System.Drawing.Imaging.ImageFormat.Bmp)
            memory.Position = 0
            Dim bitmapimage As BitmapImage = New BitmapImage()
            bitmapimage.BeginInit()
            bitmapimage.StreamSource = memory
            bitmapimage.CacheOption = BitmapCacheOption.OnLoad
            bitmapimage.EndInit()
            Return bitmapimage
        End Using
    End Function

    Private _Bild As ImageSource
    Public Property Bild As ImageSource
        Get
            Return _Bild
        End Get
        Set(value As ImageSource)
            _Bild = value
            RaisePropertyChanged()
        End Set
    End Property

    Private _Breite As Integer
    Public Property Breite As Integer
        Get
            Return _Breite
        End Get
        Set(value As Integer)
            _Breite = value
            RaisePropertyChanged()
        End Set
    End Property

    Private _Hoehe As Integer
    Public Property Hoehe As Integer
        Get
            Return _Hoehe
        End Get
        Set(value As Integer)
            _Hoehe = value
            RaisePropertyChanged()
        End Set
    End Property

    Private _Aufloesung As Integer
    Public Property Aufloesung As Integer
        Get
            Return _Aufloesung
        End Get
        Set(value As Integer)
            _Aufloesung = value
            RaisePropertyChanged()
        End Set
    End Property

    Private _Distanz As Integer
    Public Property Distanz As Integer
        Get
            Return _Distanz
        End Get
        Set(value As Integer)
            _Distanz = value
            RaisePropertyChanged()
        End Set
    End Property
End Class
